% Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
%
% In principle, this file can be redistributed and/or modified under
% the terms of the GNU Public License, version 2.
%
% However, this file is supposed to be a template to be modified
% for your own needs. For this reason, if you use this file as a
% template and not specifically distribute it as part of a another
% package/program, I grant the extra permission to freely copy and
% modify this file as you see fit and even to delete this copyright
% notice. 

\documentclass{beamer}
\usepackage{graphicx,multirow,booktabs,caption, array, listings}
\usepackage{times}  
\usepackage{url}
\usepackage{listings}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{adjustbox}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{array}
\usepackage{listings}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{amsmath}
\usepackage{color, colortbl}
\usepackage{cite}
\usepackage{siunitx}
\usepackage{tikz}

\usetikzlibrary{arrows,shapes,positioning,shadows,trees, snakes}

\tikzset{
	basic/.style  = {draw, text width=3cm, drop shadow, font=\sffamily, rectangle},
	root/.style   = {basic, rounded corners=2pt, thin, align=center,
		fill=green!30},
	level 2/.style = {basic, rounded corners=6pt, thin,align=center, fill=green!60,
		text width=8em},
	level 3/.style = {basic, thin, align=left, fill=pink!60, text width=6.5em}
}

\usepackage{array}


% There are many different themes available for Beamer. A comprehensive
% list with examples is given here:
% http://deic.uab.es/~iblanes/beamer_gallery/index_by_theme.html
% You can uncomment the themes below if you would like to use a different
% one:
%\usetheme{AnnArbor}
%\usetheme{Antibes}
%\usetheme{Bergen}
%\usetheme{Berkeley}
%\usetheme{Berlin}
%Good
\usetheme{Boadilla}
%\usetheme{boxes}
%\usetheme{CambridgeUS}
%\usetheme{Copenhagen}
%\usetheme{Darmstadt}
%\usetheme{default}
%\usetheme{Frankfurt}
%\usetheme{Goettingen}
%\usetheme{Hannover}
%\usetheme{Ilmenau}
%\usetheme{JuanLesPins}
%\usetheme{Luebeck}
%Good
%\usetheme{Madrid}
%\usetheme{Malmoe}
%\usetheme{Marburg}
%\usetheme{Montpellier}
%\usetheme{PaloAlto}
%\usetheme{Pittsburgh}
%Good
%\usetheme{Rochester}
%Good
%\usetheme{Singapore}
%\usetheme{Szeged}
%\usetheme{Warsaw}

\setbeamertemplate{footline}[frame number]{}
\setbeamertemplate{navigation symbols}{}


\title{Programming FPGAs in High Level Languages}


\author{MD Iftakharul Islam (Tamim)}
% - Give the names in the same order as the appear in the paper.
% - Use the \inst{?} command only if the authors have different
%   affiliation.

\institute[Kent State University] % (optional, but mostly needed)
{
	Software Engineer, Juniper Networks\\
	Sunnyvale, CA.\\
}

\date[\today]{}
%\date{IEEE HPSR, 2021}

% - Use the \inst command only if there are several affiliations.
% - Keep it simple, no one is interested in your street address.

% This is only inserted into the PDF information catalog. Can be left
% out. 

% If you have a file called "university-logo-filename.xxx", where xxx
% is a graphic format that can be processed by latex or pdflatex,
% resp., then you can add a logo as follows:

% \pgfdeclareimage[height=0.5cm]{university-logo}{university-logo-filename}
% \logo{\pgfuseimage{university-logo}}

% Delete this, if you do not want the table of contents to pop up at
% the beginning of each subsection:


% Let's get started
\begin{document}
	
	\begin{frame}
		\titlepage
	\end{frame}


	\begin{frame}{Work at Kent State}
		\begin{itemize}
			\item I was also a TA for \textbf{Dr. Mikhail Nesterenko} for CS-III and CS-I.
			\item At Kent State, I worked on some key technologies of routers under the supervision of \textbf{Dr. Javed Khan}.
			
	\begin{figure}[!t]
	\begin{subfigure}[t]{.6\textwidth}
		\centering
		\includegraphics[width=9cm]{router1}
		\caption{Router}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{.4\textwidth}
		\centering
		\includegraphics[width=2.5cm]{tofino}
		\caption{Intel Tofino}
	\end{subfigure}%

\end{figure} 

		\end{itemize}
	\end{frame}

	\begin{frame}{Example of Specialized Chips}
	\begin{figure}[!t]
		\begin{subfigure}[t]{.33\textwidth}
		\centering
		\includegraphics[width=3cm]{GPU}
		\caption{NVIDIA GPU}
		\end{subfigure}%
		~
		\begin{subfigure}[t]{.33\textwidth}
			\centering
			\includegraphics[width=3cm]{TPU}
			\caption{Google TPU}
		\end{subfigure}%
		~
		\begin{subfigure}[t]{.33\textwidth}
		\centering
		\includegraphics[width=3cm]{Xilinx}
		\caption{Xilinx FPGA}
		\end{subfigure}%
		\end{figure}

	\begin{figure}[!t]
	\begin{subfigure}[t]{.33\textwidth}
		\centering
		\includegraphics[width=3cm]{Altera}
		\caption{Intel FPGA}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{.33\textwidth}
		\centering
		\includegraphics[width=3cm]{Cerebras}
		\caption{Cerebras WSE}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{.33\textwidth}
		\centering
		\includegraphics[width=3cm]{quantum}
		\caption{IBM Quantum chip}
	\end{subfigure}%
\end{figure}

	\end{frame}

	\begin{frame}{FPGA Architecture}
	\begin{figure}[!t]
	\centering
	\includegraphics[width=8cm]{fpga}
	\end{figure}
	\end{frame}

	\begin{frame}{FPGA Programming Flow}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=12cm]{partitioning}
	\end{figure}
	\end{frame}

\begin{frame}{Instruction Execution Flow on Processor}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=6.5cm]{cpu-execution}
	\end{figure}
\end{frame}

	\begin{frame}{Architecture of Google's TPU}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=12cm]{systolic-array}
		\caption{Systolic array}
	\end{figure}
	\end{frame}

	\begin{frame}{Samba Nova's AI and Database accelerator}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=10cm]{plasticine}
	\caption{Plasticine architecture}
	\end{figure}
	\end{frame}

	\begin{frame}{Architecture of a 53-qubit IBM quantum processor}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=8cm]{53-qubit}
	\end{figure}
	\end{frame}

	\begin{frame}{How to program an FPGA?}
	\begin{itemize}
		\item FPGA blocks are custom hardware. So, need hardware level abstraction to program them. Historically they are programmed by Hardware Engineers by \textbf{Verilog} or \textbf{VHDL}. They are however notoriously complicated. 
		
		\item To solve this problem, several research tried to generate Verilog code from C/C++ code (this is called \textbf{High-Level Synthesis (HLS)}).
		
 	\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{hls-flow-fpga}
	\end{figure}
 
	\end{itemize}
	\end{frame}

	\begin{frame}{HLS Compilers}
 	\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{hls-flow-fpga}
	\end{figure}
	\begin{itemize}
		\item HLS Compilers:
		\begin{itemize}
		\item Xilinx Vivado
		\item Intel HLS Compiler
		\item TAPA: \url{https://github.com/UCLA-VAST/tapa}
		\item Google XLS: \url{https://github.com/google/xls}
		\end{itemize}		

		\item FPGA Place and Route Tools.
		\begin{itemize}
			\item Xilinx Vivado 
			\item Intel Quartus
			\item VTR (Open Source)  
		\end{itemize}
	\end{itemize}
	\end{frame}

	\begin{frame}{C2RTL HLS}
	\begin{itemize}
		\item While I was at Kent State, I developed a High-Level Synthesis tool named \textbf{C2RTL}. \url{https://github.com/tamimcse/c2rtl}. That was primarily designed for routing chips.
		\begin{figure}[!t]
			\centering
			\includegraphics[width=5cm]{hls-flow}
		\end{figure}
		
	\end{itemize}
	\end{frame}

		\begin{frame}{Commercial use of HLS for FPGA}
		\begin{itemize}
		\item Deep learning traning.
		\item Video transcoding
		\item Graph processing - many applications.
		\item Genome Sequencing
		\item Inference on edge devices 
	\end{itemize}
    I think, HLS can be applied to many other area.
	\begin{itemize}
		\item Any kind of accelerator.
		\item Network packet processing
	\end{itemize}
\end{frame}

		\begin{frame}{How to get an FPGA?}		
	\begin{itemize}
	\item You can buy FPGAs can be bought off-the-self. FPGA vendors include:
	\begin{itemize}
		\item Xilinx (now AMD)
		\item Altera (now Intel)
		\item Microchip	
	\end{itemize}	
	\item FPGAs are also available on AWS and Azure cloud (costs around \$1/hour).
	\item Xilinx and Intel have academic programs where they donate FPGAs for teaching and research. They also produce course materials and books. There are several universities that offer courses on High-level Synthesis for FPGAs. 
	\item FPGAs are much cheaper compared to other specialized hardware which may cost $100$s of millions of \$ to develop. Many of the specialized chips are also accessible through cloud.	 
	\end{itemize}
\end{frame}

\begin{frame}{Why Sudden Explosion of Domain Specific Computing?}			
	\begin{itemize}
		\item Currently almost all the system and AI companies (e.g. Google, Microsoft, Amazon, Tesla, etc) are making their custom chips. Currently, there are more than $100$ chip startups.
		\begin{itemize}
		\item As Moore's law has slowed down, CPUs are not getting faster.
		\item Computing needs are growing very fast too due to AI/ML.
		\item General purpose computer also cannot solve many real world problems. We need special types of computer for that. For instance, Quantum computer is expected to be able to solve some problems that current computers cannot solve.			
		\end{itemize}
		
		\item A big challenge for the industry is to develop custom software stack for each chip is very expensive. 
	\end{itemize}					
\end{frame}


\begin{frame}{Challenges of HLS}
	\begin{itemize}
		\item Unfortunately HLS tools still have many limitations.
		\begin{itemize}
			\item Current HLS tool don't accurate hardware architecture information. So, HLS generated code often result poor quality in terms of clock frequency. So, research is needed on physical-aware HLS.	
			
			\item Place and Route in FPGA is a very complex process (often takes several hours, sometimes a day!!). Programmers on the other hand used to several second compile time. So, novel research is need to minimize the run-time of the place and route process.
			
			\item A C/C++ program for CPU often perform very poorly on FPGA. Programmer needs to write specialized C/C++ for FPGA. Such specialized code negates many advantages of software. Some research developed another compiler for that generates FPGA efficient C/C++ code from generic C/C++ code (e.g. Marlin Compiler)  
			
			\item Formal verification is needed. We need tools that can tell if the generated Verilog code is equivalent to the C/C++. Currently, hardware verification cost exceeds actual development cost. So, formal verification would be very beneficial.
			\end{itemize}
			\end{itemize}
		\end{frame}
		
		


\begin{frame}{}
	\centering \Large
	\Huge{Thank You}
\end{frame}
	
\end{document}


